<html>
	<head>
		<!-- development version, includes helpful console warnings
		<script src="https://cdn.jsdelivr.net/npm/vue@2/dist/vue.js"></script>
		 -->
		<!-- production version, optimized for size and speed -->
		<script src="https://cdn.jsdelivr.net/npm/vue@2"></script>
		<script src="https://unpkg.com/axios/dist/axios.min.js"></script>


		<link href="https://fonts.googleapis.com/css?family=Roboto:100,300,400,500,700,900" rel="stylesheet">
		<link href="https://cdn.jsdelivr.net/npm/@mdi/font@4.x/css/materialdesignicons.min.css" rel="stylesheet">
		<link href="https://cdn.jsdelivr.net/npm/vuetify@2.x/dist/vuetify.min.css" rel="stylesheet">
		<meta name="viewport" content="width=device-width, initial-scale=1, maximum-scale=1, user-scalable=no, minimal-ui">


	</head>
        <!-- somehow darkmode was not always obeyed. -->
	<style>
	body {color: rgba(255,255,255,0.7) }
	</style>
	<body>
		<div id="app">
			<div id="search-results">
				<v-app id="inspire">
					<v-card>
						<v-card-title>
							<h2>LambdaDB </h2>
							<v-spacer></v-spacer>
								Time: {{ duration }}
							<v-spacer></v-spacer>
								Results: {{ count }}
							<v-spacer></v-spacer>
							<v-text-field
							  v-model.trim="searchTerm"
							  append-icon="mdi-magnify"
							  label="Search"
							  v-on:input="runSearch()"
							  single-line
							 hide-details
							></v-text-field>
						  </v-card-title>
						  <v-card>
							<v-container
							class="pa-6 "
							fluid
							elevation=6
						  	>
							<v-data-table
								:headers="headers"
								:items="searchResults"

								:items-per-page="pageSize"
								:footer-props="{     itemsPerPageOptions:[10,20,30,50] }"

								:server-items-length="count"
								:loading="loading"
								:dense=true
								:dark=true

							        :sort-by.sync="sortBy"
							        :sort-desc.sync="sortDesc"

								:dark=false
								:dense=true

							        :sort-by.sync="sortBy"
							        :sort-desc.sync="sortDesc"

								@update:sort-by="handleEvent('sort-by', $event)"
								@update:sort-desc="handleEvent('sort-desc', $event)"


								@update:page="updatePage($event)"

								@update:items-per-page="updateItemsPerPage($event)"
								fixed-header
								class="elevation-4 .theme--dark.v-data-table"
								:multi-sort=true
							>
							<template v-slot:header="props">
								<th v-for="(head, index) in headers">
								</v-col>
								</v-row>
									<v-row>
										<v-select
											:items="columnOptions"
											v-model="columnOptionsValues[index]"
											attach
											:item-value="columnOptionsValuesInitial"
											:item-text="columnOptionsValuesInitial"
											v-on:input="runSearch()"
											solo
											hide-details
											label="startswith"
											dense

											:flat=true
										></v-select>
											</v-col>
											<v-col class="mb-6">
										<v-text-field
											v-model="columnSearchTerm[index]"
											v-on:input="runSearch()"
											:dark=true
											dense
											clearable
											elevation=5
											outlined
											disable-filtering
											:flat=true
											hide-details
											class="styled-input"
										></v-text-field>
									</v-card>
									</th>
					  			</template>
							</v-data-table>
						</v-container>
						</v-card>
					</v-card>
				  </v-app>
			</div>
		</div>

	<script src="https://cdn.jsdelivr.net/npm/vue@2.x/dist/vue.js"></script>
	<script src="https://cdn.jsdelivr.net/npm/vuetify@2.x/dist/vuetify.js"></script>
	<script>
		const CancelToken = axios.CancelToken;
		const source = CancelToken.source();
		var app = new Vue({
			el: "#app",
			vuetify: new Vuetify({theme: { dark: true }, }),
			created() {
      				if (this.apiHost.length == 0 ) {
        				this.apiHost = location.origin
      				}
			},
			computed:  {
				headers () {
					return this.columns.map( item => ({
						text: item.label,
						align: 'start',
						value: item.name,
					})
				)
				},
				currentColumns () {
					return this.columns.map( item => (
						item.name
					))
				},
				apiUrl () {
					n = []
					for (i=0;i<this.columnSearchTerm.length;i++) {
						if (!this.columnSearchTerm[i]) {
							continue
						}
						type = this.columnOptionsValues[i] || this.columnOptionsValuesInitial
						item = `&${type}-${this.columns[i].name}=${ this.columnSearchTerm[i]}`
						n.push(item)
					}

					sortingOrders= []
					if (this.sortBy && this.sortBy[0] !== undefined ) {
						for(i=0;i<this.sortBy.length;i++) {
							isDesc = this.sortDesc[i] ? "" : "-"
							sortingOrders.push(`&sortby=${isDesc}${this.sortBy[i]}`)
						}
					}
					return this.apiHost + "/" + "search/?page=" + this.currentPage + "&pagesize=" + this.pageSize +  "&search=" + this.searchTerm  +  n.join("") + sortingOrders.join("")

				}
			},
			watch: {
				typeAheadWatch( val ) {
					console.log("consoile", val)
				}
			},
			data: {
				searchResults: [],
				sortDesc: [],
				sortBy: [],
				searchTerm: "",
				count: 0,
				loading: false,
				dark: true,
				apiHost: "",
				duration: "",
				page: 1,
				pageSize: 2000,
				pageTotal: 0,
				currentPage: 1,
				columns: [],

				prevSearchTerm: "",
				itemsPerPage: 20,
				columnSearchTerm: [],
				columnSort: [],
				sortingOrder: [],
				columnOptions: ["match", "contains", "startswith", "!match", "!contains", "!startswith", "lte", "gte"],
				columnOptionsValues: [],
				columnOptionsValuesInitial: "startswith",

				columnTypeAhead: [ ],
				isColumnLoading: [],
			},
			watch: {
				options: {
				handler () {
					this.runSearch()
				},
				//deep: true,
				},
			},
			mounted () {
				this.runSearch()
			},
			methods: {
				handleEvent(name, event) {

					console.log(event)

					this.runApiCall()

					console.log("handle", name, event)
					console.log("sort sync", this.sortBy, this.sortDesc)
				},
				runApiCall: function() {
					if (source.cancel != undefined) {
						source.cancel('Operation canceled by the user.');
					}
					axios.get(this.apiUrl, {
						cancelToken: new CancelToken(function executor(c) {
            				source.cancel = c;
         				 }),
						}).catch(function (thrown) {
						if (axios.isCancel(thrown)) {
							console.log('Request canceled', thrown.message);
						} else {
							// handle error
							console.log('Error');
						}}
					).then(res => (
						this.setResult(res))).catch((err) => {
							this.setEmpty()
            				console.log("err", err)
          				}).finally(
							this.loading = false
						  )
				},
				runSearch:  function(event) {
					if (this.searchTerm !== this.prevSearchTerm) {
						this.currentPage=1
					}
					this.loading = true
					this.prevSearchTerm = this.searchTerm
					this.runApiCall()
		},
		typeAheadUrl (columnName) {
			n = []
			for (i=0;i<this.columnSearchTerm.length;i++) {
				if (!this.columnSearchTerm[i]) {
					continue
				}
				type = this.columnOptionsValues[i] || this.columnOptionsValuesInitial
				column = this.columns[i].name
				searchTerm = this.columnSearchTerm[i]
				item = `${type}-${column}=${searchTerm}`
				n.push(item)
			}
			console.log("options val", this.columnOptionsValues)
			console.log("n", n)
			console.log("all n", n.join("&"))

			return this.apiHost + "/typeahead/" +  columnName + "/?" +  "&search=" + this.searchTerm +  n.join("&") + "&limit=15"
		},
		runTypeAhead: function (index) {
			console.log("index", index)
			//this.columnTypeAhead[index] = ["4", "5", "6"]
            this.isColumnLoading[index] = true
			columnName = this.columns[index].name
			if (source.cancel != undefined) {
						source.cancel('Operation canceled by the user.');
					}
					axios.get(this.typeAheadUrl(columnName), {
						cancelToken: new CancelToken(function executor(c) {
            				source.cancel = c;
         				 }),
						}).catch(function (thrown) {
							if (axios.isCancel(thrown)) {
								console.log('Request canceled', thrown.message);
							} else {
								// handle error
								console.log('Error');
							}}
					).then(res => {
						if (res !== undefined || res.status !== 204) {
							console.log(res.data)
							this.columnTypeAhead[index]  = res.data
							console.log(this.columnTypeAhead)
						}

					}).catch((err) => {
            				console.log("err", err)
          				}).finally(
							this.isColumnLoading[index] = false
						  )

		},
		setResult: function(resp) {
				if (resp === undefined) {
					//this.setEmpty()
					return
				}
				this.count = parseInt(resp.headers["total-items"])
				this.duration = resp.headers["query-duration"]
				this.page = parseInt(resp.headers["page"])
				this.pageSize = parseInt(resp.headers["page-size"])
				this.pageTotal = parseInt(resp.headers["total-pages"])
				if (resp.status == 204) {
					return
				}
				this.searchResults = resp.data.data
				this.columns = resp.data.meta.fields
				this.loading = false

		},
		updateItemsPerPage: function(event) {
			if (event  === undefined) {
					return
				}
				this.itemsPerPage = event
				this.pageSize = event
				this.runSearch()
		},
		setEmpty: function() {
					this.searchResults = []
					this.count = 0
					this.loading = false
					this.duration = ""
					this.page = 0
					this.pageTotal = 0
					this.currentPage = 1

					this.sortDesc = ""
				},
				updateSort: function() {
					this.runSearch()

				},
				updatePage(event) {
					if (event  === undefined) {
					return
				}
				this.currentPage = event

				this.runSearch()

				}
			}
		});
	</script>
	</body>

										<!--
										<v-autocomplete
											v-model="columnSearchTerm[index]"
											:items="columnTypeAhead[index]"
											:loading="isColumnLoading[index]"
											clearable
											hide-details
											hide-selected
											item-text="name"
											item-value="symbol"
											label="Search..."
											:search-input.sync="typeAheadWatch"
										>
										-->
</html>
